image: zenika/alpine-maven:3-jdk8

stages:
  - release

variables:
  MAVEN_CLI_OPTS: "-s ci/settings.xml --batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"

.setup-git:
  before_script:
    - apk add --update bash openssh-client git
    - eval $(ssh-agent -s)
    - echo "${DEPLOY_KEY_GITLAB_ID_RSA}" | base64 -d | ssh-add -
    - git config --global user.email "$GITLAB_USER_EMAIL"
    - git config --global user.name "$GITLAB_USER_NAME"
    - mkdir -p ~/.ssh
    - chown 7000 ~/.ssh
    - ssh-keyscan ${CI_SERVER_HOST} > ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
    - echo "git@${CI_SERVER_HOST}:/${CI_PROJECT_PATH}.git"
    - git remote set-url --push origin "git@${CI_SERVER_HOST}:/${CI_PROJECT_PATH}.git"

.checkout-release-from:
  script:
    - git fetch --all
    - git checkout $CI_DEFAULT_BRANCH
    - CI_BRANCH_COMMIT_SHA=$(git rev-parse HEAD)
    - |
      if [ "$CI_BRANCH_COMMIT_SHA" = "$CI_COMMIT_SHA" ] ; then
        echo "[INFO ] Working on branch $CI_DEFAULT_BRANCH"
      else
        echo "[ERROR] The last commit on the branch $CI_DEFAULT_BRANCH ($CI_BRANCH_COMMIT_SHA) does not match the commit from the tag $CI_COMMIT_TAG ($CI_COMMIT_SHA)"
        echo "[ERROR] This feature only works when tagging the default branch of the project"
        exit 1
      fi

.calculate-version-info: 
  script:
    - #determine current patch version
      patch=$(echo -e $CI_COMMIT_TAG  | sed -r 's/.+\.(\d+)\.(RELEASE|M\d+|RC\d+)$/\1/'); echo patch=${patch}
    - #increment patch if release
      echo $CI_COMMIT_TAG | grep -q '\.RELEASE$' && patch=$((patch +1)); echo new path=${patch}
    - 'nextVersion=$(echo $CI_COMMIT_TAG | sed -r "s/v(\d+)\.(\d+)\.(\d+)\..+/\1.\2\.${patch}-SNAPSHOT/"); echo nextVersion: $nextVersion'
    - 'releaseVersion=${CI_COMMIT_TAG:1}; echo releaseVersion: ${releaseVersion}'
    - 'tagByMvn=${CI_COMMIT_TAG}-tbm; echo tagByMvn: ${tagByMvn}'

.move-tag: 
  script:
    - sha1ForTagByMvn=$(git show-ref -s ${tagByMvn})
    - git tag --force ${CI_COMMIT_TAG} ${sha1ForTagByMvn}
    - git push --force --tags
    - git push --delete origin ${tagByMvn}

release:
  stage: release
  before_script:
    - !reference [.setup-git, before_script]
  script:
    - !reference [.checkout-release-from, script]
    - !reference [.calculate-version-info, script]
    - 'mvn $MAVEN_CLI_OPTS -Dtag=${tagByMvn} -DreleaseVersion=${releaseVersion} -DdevelopmentVersion=${nextVersion} release:prepare release:perform'
    - !reference [.move-tag, script]
  rules:
    - if: '$CI_COMMIT_TAG =~ /^v(\d+\.){3}(RELEASE|M[1-9]+|RC[1-9]+)$/'
      when: always
    - when: never
